#include <stdio.h>      // I/O
#include <conio.h>      // getch
#include <math.h>	// sin, cos, tg, ctg
#include <mem.h>        // malloc

const grid[12][12] = {		// map
	9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 9,
	9, 0, 0, 10, 0, 0, 0, 0, 0, 12, 0, 1,
	1, 0, 10, 2, 0, 0, 0, 0, 0, 4, 0, 9,
	9, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 1,
	1, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 9,
	9, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 1,
	1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
	9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
	1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
	9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
	1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9
};

	long istable[1800],ictable[1800],istable2[1800],ictable2[1800],hht[1200]; // sin and cos tables for optimization
	long px=150000, py=150000, newpx, newpy, stepx, stepy;	// player position
	int i,stride2=3, heading=980, turn=30;	// step, view angle and turning speed
	double angle,factor=0.003490658;
	char vs[50][80], vs2[50][80];	//virtual screen

	char *pxx, *pyy, ch;	//
	long x1,y1,xx,yy,xg,yg;	//

void computeview() {	// RAYCASTING
	long a;				//angolo visuale
	int k= 0;	     		//posizione mappa
	long l;       			//distanza
	int mx=0;

	memcpy(vs, vs2, 4000);	//cancella schermo

	for (a=heading+160;a>heading-160;a=a-4)
	{
		xx=px;
		yy=py;
		l=0;
		stepx=istable[(a+1800)%1800];
		stepy=ictable[(a+1800)%1800];
		do
		{
			xx=xx-stepx;
			yy=yy-stepy;
			l=l+2;
			k=grid[*(pxx+2)][*(pyy+2)];
		}
		while (k==0);
		for (i=24-hht[l]-1;i<=25+hht[l];i++)
			vs[i][mx]=32+k;
		mx=mx+1;
	}
	//stampa
	gotoxy(1,1);
	vs[48][79]='\0';
	puts((char*)vs);
}

void main(void)
{
	pxx=(char*)&xx;
	pyy=(char*)&yy;

	for (i=0;i<1200;i++) if ((hht[i]=((-3000+(64*150))/(i+1))/3)>23) hht[i]=23;

	for (y1=0;y1<50;y1++) for (x1=0;x1<80;x1++) vs2[y1][x1]='@';

	for (i=0;i<1799;i++)
	{
		angle=i*factor;
		istable[i]=(sin(angle)*0.1*65535)/5;
		ictable[i]=(cos(angle)*0.1*65535)/5;
		istable2[i]=(sin(angle)*0.1*65535)*stride2;
		ictable2[i]=(cos(angle)*0.1*65535)*stride2;
	}
	asm {
		mov ax, 1112h;
		int 10h;
	}
	do
	{
	 //	switch (ch=getch())   <----- it was too slow!
		switch (ch=inport(0x60))  // keyboard port

		{
			case 75: //left
				heading = (heading + turn) % 1800;
				computeview();
			break;
			case 77: //right
				heading = (heading + (1800 - turn)) % 1800;
				computeview();
			break;
			case 72: //up
				newpx = px - (istable2[heading]);
				newpy = py - (ictable2[heading]);
				if (grid[newpx / 65535][newpy / 65535] == 0)
				{
					px = newpx;
					py = newpy;
					computeview();
				}
			break;
			case 80: //down
				newpx = px + (istable2[heading]);
				newpy = py + (ictable2[heading]);
				if (grid[newpx / 65535][newpy / 65535] == 0)
				{
					px = newpx;
					py = newpy;
					computeview();
				}
			break;
		}
		while (kbhit())  // flush keyb buffer - cool trick, isn't it? =p
			getch();
	}
	while (ch!=1);
}
