#include <stdio.h>      // I/O
#include <conio.h>      // getch
#include <math.h>	// sin, cos, tg, ctg
#include <mem.h>        // malloc

const grid[12][12] = {		// map
	9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 9,
	9, 0, 0, 10, 0, 0, 0, 0, 0, 12, 0, 1,
	1, 0, 10, 2, 0, 0, 0, 0, 0, 4, 0, 9,
	9, 0, 0, 0, 0, 0, 0, 0, 0, 12, 0, 1,
	1, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 9,
	9, 0, 0, 0, 0, 7, 7, 0, 0, 0, 0, 1,
	1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
	9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
	1, 0, 13, 0, 0, 0, 0, 8, 0, 12, 0, 9,
	9, 0, 5, 0, 0, 0, 0, 7, 0, 4, 0, 1,
	1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9
};

	long istable[1800],ictable[1800],istable2[1800],ictable2[1800],hht[1200]; // sin and cos tables for optimization
	long px=150000, py=150000, newpx, newpy, stepx, stepy;	// player position
	int i,stride2=3, heading=980, turn=30;	// step, view angle and turning speed
	double angle,factor=0.003490658;

	char *pxx, *pyy, ch;	//
	long x1,y1,xx,yy,xg,yg;	//

void setvga(void)
{
	asm {
		mov ax, 0x13	// mode 320x200 256 colors
		int 0x10	// video interrupt
	}
}

void settext(void)
{
	asm {
		mov ax, 0x03	// textmode
		int 0x10
	}
}

void putpixel (int X, int Y, char Color)
{
	// advanced puttingpixel optimization by Link - see documentation for info
	char far *vga = (char far*)0xA0000000L;

	asm {
	 les di, vga
	 mov    DI, [Y]
	 mov    BX, DI
	 shl    DI, 6
	 shl    BX, 8
	 add    DI, BX
	 add    DI, [X]
	 mov    AL, [Color]
	 stosb
	}
}

void cls (void)		// clear vga screen - Link rulezZz
{
	char far *vga = (char far*)0xA0000000L;	// video mem

	asm {
	 les di, vga	// es:di now point at vga (direct video memory access)
	 xor ax, ax	// ax = 0
	 mov cx, 32000
	 rep stosw  // for 32000 times --> put 2 bytes  (320x200 = 64k)
	}
}

void computeview()	// RAYCASTING
{
	long a;				//angolo visuale
	int k= 0;			//posizione mappa
	long l;  			//distanza
	int mx=0;

	//for (y1=0;y1<200;y1++) for (x1=0;x1<320;x1++) putpixel(x1 ,y1, 0);
	//delay(100);
	cls(); // optimized vers.

	for (a=heading+160;a>heading-160;a=a-1)
	{
		xx=px;
		yy=py;
		l=0;
		stepx=istable[(a+1800)%1799];
		stepy=ictable[(a+1800)%1799];
		do
		{
			xx=xx-stepx;
			yy=yy-stepy;
			l=l+2;
			k=grid[*(pxx+2)][*(pyy+2)];
		}
		while (k==0);
		for (i=99-hht[l]-1;i<=100+hht[l];i++)
			putpixel(mx, i, 33+k);
		mx=mx+1;
	}
}

void main(void)
{
	setvga();
	pxx=(char*)&xx;
	pyy=(char*)&yy;

	for (i=0;i<1200;i++) if ((hht[i]=((-3000+(64*150))/(i+1))/3)>80) hht[i]=80;

	for (i=0;i<1799;i++)
	{
		angle=i*factor;
		istable[i]=(sin(angle)*0.1*65535)/5;
		ictable[i]=(cos(angle)*0.1*65535)/5;
		istable2[i]=(sin(angle)*0.1*65535)*stride2;
		ictable2[i]=(cos(angle)*0.1*65535)*stride2;
	}
	do
	{
	 //	switch (ch=getch())   <----- it was too slow!
		switch (ch=inport(0x60))

		{
			case 75: //left
				heading = (heading + turn) % 1800;
				computeview();
			break;
			case 77: //right
				heading = (heading + (1800 - turn)) % 1800;
				computeview();
			break;
			case 72: //up
				newpx = px - (istable2[heading]);
				newpy = py - (ictable2[heading]);
				if (grid[newpx / 65535][newpy / 65535] == 0)
				{
					px = newpx;
					py = newpy;
					computeview();
				}
			break;
			case 80: //down
				newpx = px + (istable2[heading]);
				newpy = py + (ictable2[heading]);
				if (grid[newpx / 65535][newpy / 65535] == 0)
				{
					px = newpx;
					py = newpy;
					computeview();
				}
			break;
		}
		while (kbhit())  // flush keyb buffer - cool trick, isn't it? =p
			getch();
	}
	while (ch!=1);
	settext();
}